/////////////////////////////////////////////////////////////////////////////////////////
//																
//	                                 NN											
//	         ___JNN)      .___J      4N          _____.									
//	      JNNF"4NNN    .NN"4NN)      NN       JNF4L_F4NN.								
//	     (N`  .NNNF   JN` (NNF      JN`     JNF `NNN` NN)								
//	     (N) (NNNN)  (N`  NNN      JN`     JN`   NNN (NN)   _NNLJNN .JNNN.    .NNNL		
//	        (N)(NN`  (N) .NNN    .NN      .N)   (NNLJNN`  JNNNNNNF`JNF`4NN)  (NF`NN		
//	       (N) JNN    "` `NN)   JNF       (N    JNNNNNNN. "`NNNF  JNF  `NN)  (NN		
//	      (N`  NNN        NN) .NN`        (N)   NNN  (NN)  (NN)  (NN`   NN)  `NNN		
//	     (N""""NN)        NNLJNF          `NNN (NN)  .NN)  JNN   (NN   (NN    (NN)		
//	    JN`   (NN)        NNNN`             "" JNN`  JNN   NNF   (NN) .NN` NN).NN) .NN	
//	   JN`    NNNLJ)      NNF                .JNNF _NNF   (NN)    NNNNNF   4NNNNF  (NN	
//	._NN                  "`                `""""""""									
//	NNF															
//																		
/////////////////////////////////////////////////////////////////////////////////////////
//                               
//   Script for Adobe Photoshop CS and higher.  Copyright 2004 AV Bros.
//                             
/////////////////////////////////////////////////////////////////////////////////////////






/////////////////////////////////////////////////////////////////////////////////////////
$.level = 0;
var av_ScriptMainObject = new Object();
av_ScriptMainObject.msg_OnlyCS=			"This script is only for Adobe Photoshop CS and higher.";
av_ScriptMainObject.msg_OpenDocument=	"Please open or create the document before running the script.";
av_ScriptMainObject.msg_SelectDocument=	"Please select the document before running the script.";
av_ScriptMainObject.msg_IncorrectConfig="Broken config file, or incorrect version.";
av_ScriptMainObject.wndMain=null;
av_ScriptMainObject.startRulerUnits=null;
av_ScriptMainObject.startTypeUnits=null;
av_ScriptMainObject.startDialogsMode=null;
av_ScriptMainObject.startDocRef=null;
function av_wrkInitHostStartValues(){
if (av_ScriptMainObject==null) return false;
try{
if (this.documents.length>0)
av_ScriptMainObject.startDocRef = this.activeDocument;
}
catch(e){
av_ScriptMainObject.startDocRef=null;
}
try{
av_ScriptMainObject.startRulerUnits  = this.preferences.rulerUnits;
av_ScriptMainObject.startTypeUnits  = this.preferences.typeUnits;
av_ScriptMainObject.startDialogsMode  = this.displayDialogs;
}
catch(e){
}
return true;
}
function av_wrkRestoreHostStartValues(){
if (av_ScriptMainObject==null) return false;
if ((this.preferences.rulerUnits!=av_ScriptMainObject.startRulerUnits) && (av_ScriptMainObject.startRulerUnits!=null)){
this.preferences.rulerUnits=av_ScriptMainObject.startRulerUnits;
}
if ((this.preferences.typeUnits!=av_ScriptMainObject.startTypeUnits) && (av_ScriptMainObject.startTypeUnits!=null)){
this.preferences.typeUnits=av_ScriptMainObject.startTypeUnits;
}
if ((this.displayDialogs!=av_ScriptMainObject.startDialogsMode) && (av_ScriptMainObject.startDialogsMode!=null)){
this.displayDialogs=av_ScriptMainObject.startDialogsMode;
}
return true;
}
function av_wrkInitHostParams(Units,TypeUnits,DisplayDialogs){
if (Units!=null){
this.preferences.rulerUnits=Units;
}
if (TypeUnits!=null){
this.preferences.typeUnits=TypeUnits;
}
if (DisplayDialogs!=null){
this.displayDialogs=DisplayDialogs;
}
}
function av_wrkTestHost(OnlyCS,DocumentOpen,ShowErrors){
if (OnlyCS){
if (this.version.split(".")[0]<8) {
if (ShowErrors) alert(av_ScriptMainObject.msg_OnlyCS);
return false;
}
}
if (DocumentOpen){
if (this.documents.length==0){
if (ShowErrors) alert(av_ScriptMainObject.msg_OpenDocument);
return false;
}
var tmp_app=null;
try{
tmp_app=this.activeDocument;
}
catch(e){
tmp_app=null;
}
if (tmp_app==null){
if (ShowErrors) alert(av_ScriptMainObject.msg_SelectDocument);
return false;
}
}
return true;
}
function av_wrkDoModal(TheWindow){
if (TheWindow==null) return 0;
return TheWindow.show();
}
function av_wrkCheckForSelection(){
if (av_ScriptMainObject.startDocRef==null) return false;
try{
var ref=new ActionReference();
ref.putProperty(charIDToTypeID("Chnl"), charIDToTypeID("fsel"));
var desc=new ActionDescriptor();
desc.putReference(charIDToTypeID("null"),ref);
executeAction(charIDToTypeID("Trnf"),desc,DialogModes.NO);
}
catch(e){
return false;
}
return true;
}
function av_wrkWriteDataToFile(theFile,theData,showErrors){
try{
var av_file=new File(theFile);
av_file.open('w','TEXT','????');
var DataString="";
av_file.write(theData.version+"\n\n");
for (i=0;i<theData.count;i++){
av_file.write(theData.data.name[i]+":"+theData.data.value[i]+"\n");
}
av_file.close();
}
catch (err){
if (showErrors) alert(err);
return false;
}
return true;
}
function av_wrkReadDataFromFile(theFile,showErrors,versionString){
theReturnData=new Object();
theReturnData.count=0;
theReturnData.data=new Object();
theReturnData.data.name=new Array();
theReturnData.data.value=new Array();
try{
var av_file=new File(theFile);
av_file.open('r','TEXT','????');
var DataString="";
var firstLine=true;
while (!av_file.eof){
DataString=av_file.readln();
if (firstLine){
if (DataString!=versionString){
throw(av_ScriptMainObject.msg_IncorrectConfig);
}
firstLine=false;
}
var dataArray=DataString.split(":");
if ((dataArray[0]!=null) && (dataArray[0]!="")){
theReturnData.data.name[theReturnData.count]=dataArray[0];
theReturnData.data.value[theReturnData.count]=DataString.substr(dataArray[0].length+1);
theReturnData.count++;
}
}
av_file.close();
}
catch (err){
if (showErrors) alert(err);
return null;
}
return theReturnData;
}
function av_wrkGetListOfSelectedFilesInPSBrowser_II(){
var retObject=new Object();
retObject.count=0;
retObject.list= new Array();
retObject.firstFlaggedFile=null;
try{
var fileBrowserID=stringIDToTypeID('fileBrowser');
var CountID=stringIDToTypeID('selectedItems');
var FilesListID=charIDToTypeID('flst');
var SelectedID = charIDToTypeID('fsel');
var FlaggedID = stringIDToTypeID('flagged');
var PathID=charIDToTypeID('Path');
var the_ref=new ActionReference();
the_ref.putProperty(charIDToTypeID('Prpr'),fileBrowserID);
the_ref.putEnumerated(charIDToTypeID('capp'),charIDToTypeID('Ordn'),charIDToTypeID('Trgt'));
var the_desc = executeActionGet(the_ref);
var ActDesc=the_desc.getObjectValue(fileBrowserID);
if ((ActDesc.hasKey(CountID)) && (ActDesc.getInteger(CountID)>0)){
var theList=ActDesc.getList(FilesListID);
for (i=0; i<theList.count;i++){
var fDesc=theList.getObjectValue(i);
if ((fDesc.hasKey(PathID)) && (fDesc.count>0) && (fDesc.hasKey(SelectedID))){
if (fDesc.getBoolean(SelectedID)){
var fsObject=fDesc.getPath(PathID);
if (fsObject instanceof File){
retObject.list[retObject.count++] = fsObject;
}
}
}
if (retObject.firstFlaggedFile==null){
if ((fDesc.hasKey(PathID)) && (fDesc.count>0) && (fDesc.hasKey(FlaggedID))){
if (fDesc.getBoolean(FlaggedID)){
var fsObject=fDesc.getPath(PathID);
if (fsObject instanceof File){
retObject.firstFlaggedFile = fsObject;
}
}
}
}
}
}
}
catch (e){
}
return retObject;
}
var g_CollectedHostInfo=new Object();
function CollectHostStateInfo(){
var err_Conditions="Open more than one document or select some files in Photoshop File Browse. \n\nPlease refer to documantation about usage of this script.";
var err_ConditionsActive="No active document.\n\nPlease refer to documantation about usage of this script.";
g_CollectedHostInfo.HaveActiveDocument=(av_ScriptMainObject.startDocRef!=null);
g_CollectedHostInfo.HaveManyOpenDocuments=(this.documents.length>1);
g_CollectedHostInfo.FBObject=av_wrkGetListOfSelectedFilesInPSBrowser_II();
g_CollectedHostInfo.HaveSelectedFilesInFB=(g_CollectedHostInfo.FBObject.count>0);
g_CollectedHostInfo.HaveFlaggedInFB=(g_CollectedHostInfo.FBObject.firstFlaggedFile!=null);
if ((!g_CollectedHostInfo.HaveManyOpenDocuments) && (!g_CollectedHostInfo.HaveSelectedFilesInFB)){
alert(err_Conditions);
return false;
}
if ((g_CollectedHostInfo.HaveManyOpenDocuments) && (!g_CollectedHostInfo.HaveSelectedFilesInFB) && (!g_CollectedHostInfo.HaveActiveDocument)){
alert(err_ConditionsActive);
return false;
}
return true;
}
var g_Settings=new Object();
var gc_Source_FB="FileBrowser";
var gc_Source_OP="Documents";
var gc_FB_Destination_Active="Active";
var gc_FB_Destination_FlaggedLike="Flagged";
var gc_FB_Destination_SelectedLike="Selected";
var gc_OP_Destination_Active="Active";
var gc_OP_Destination_New="New";
var gc_Naming_Document="DocumentName";
var gc_Naming_Number="Numbering";
function InitSettings_Defaults(){
g_Settings.Source=gc_Source_FB;
g_Settings.Destination_FB=gc_FB_Destination_Active;
g_Settings.Destination_OP=gc_OP_Destination_Active;
g_Settings.Naming=gc_Naming_Document;
g_Settings.Naming_Prefix="Layer:";
g_Settings.Naming_StartNumber=1;
return true;
}
var avc_ConfigFileVersionString="AV Bros. Collector 1.0 Config File";
var avc_ConfigFileName="AVCollector1.0.cfg";
function LoadLastSettings(){
var DataObject=av_wrkReadDataFromFile("~/"+avc_ConfigFileName,false,avc_ConfigFileVersionString);
if (DataObject==null) return;
for (i=0;i<DataObject.count;i++){
var SplitArray=DataObject.data.name[i].split(".");
switch (SplitArray[0]){
case "Source":
g_Settings.Source=DataObject.data.value[i];
break;
case "Destination_FB":
g_Settings.Destination_FB=DataObject.data.value[i];
break;
case "Destination_OP":
g_Settings.Destination_OP=DataObject.data.value[i];
break;
case "Naming":
g_Settings.Naming=DataObject.data.value[i];
break;
case "Naming_Prefix":
g_Settings.Naming_Prefix=DataObject.data.value[i];
break;
case "Naming_StartNumber":
g_Settings.Naming_StartNumber=DataObject.data.value[i];
break;
}
}
}
function SaveLastSettings(){
DataToStore=new Object();
DataToStore.count=0;
DataToStore.data=new Object();
DataToStore.data.name=new Array();
DataToStore.data.value=new Array();
DataToStore.version=avc_ConfigFileVersionString;
var k=0;
DataToStore.data.name[k]="Source";
DataToStore.data.value[k]=g_Settings.Source;
k++;
DataToStore.data.name[k]="Destination_FB";
DataToStore.data.value[k]=g_Settings.Destination_FB;
k++;
DataToStore.data.name[k]="Destination_OP";
DataToStore.data.value[k]=g_Settings.Destination_OP;
k++;
DataToStore.data.name[k]="Naming";
DataToStore.data.value[k]=g_Settings.Naming;
k++;
DataToStore.data.name[k]="Naming_Prefix";
DataToStore.data.value[k]=g_Settings.Naming_Prefix;
k++;
DataToStore.data.name[k]="Naming_StartNumber";
DataToStore.data.value[k]=g_Settings.Naming_StartNumber;
k++;
DataToStore.count=k;
av_wrkWriteDataToFile("~/"+avc_ConfigFileName,DataToStore,false);
}
function ReInitSettingByStartConditions(){
if (!g_CollectedHostInfo.HaveManyOpenDocuments) g_Settings.Source=gc_Source_FB;
if (!g_CollectedHostInfo.HaveSelectedFilesInFB) g_Settings.Source=gc_Source_OP;
if (g_Settings.Source==gc_Source_FB){
if ((g_Settings.Destination_FB==gc_FB_Destination_Active) && (!g_CollectedHostInfo.HaveActiveDocument)) g_Settings.Destination_FB=gc_FB_Destination_SelectedLike;
if ((g_Settings.Destination_FB==gc_FB_Destination_FlaggedLike) && (!g_CollectedHostInfo.HaveFlaggedInFB)) g_Settings.Destination_FB=gc_FB_Destination_SelectedLike;
}
return true;
}
function BuildUI(){
var av_uiMainWndWidth=550;
var av_uiMainWndHeight=420;
var txt_pnlSrcDest="Source/Destination";
var txt_rbSourceFB="Get selected images from File Browser and...";
var txt_rbSourceOP="Get all open documents and...";
var txt_rbActive="put them to the active document";
var txt_rbFBFlagged="put them to the new document based on the first flagged file in File Browser";
var txt_rbFBSelected="put them to the new document based on the first selected file in File Browser";
var txt_rbOPNew="put them to the new document based on active document";
var txt_pnlNaming="Layer naming";
var txt_rbLNByDoc="By the file/document name";
var txt_rbLNByNN="Automatically numerate layers";
var txt_stPrefix="Layer name prefix";
var txt_stStartValue="Start value";
var txt_btnRun="Run";
var txt_btnCancel="Cancel";
var txt_stCopyright="Copyright 2004 AV Bros.   Web: http://www.avbros.com";
av_ScriptMainObject.wndMain = new Window('dialog','AV Bros. Collector 1.0 ',[0,0,av_uiMainWndWidth,av_uiMainWndHeight]);
var av_wndMain=av_ScriptMainObject.wndMain;
if (av_wndMain==null) return false;
av_wndMain.center();
var ui_SDTop=20;
av_wndMain.pnlSrcDest=av_wndMain.add('panel',[10,ui_SDTop,av_uiMainWndWidth-10,ui_SDTop+210],txt_pnlSrcDest);
av_wndMain.pnlSrcDest.rbSourceFB=av_wndMain.pnlSrcDest.add('radiobutton',[10,20,500,40],txt_rbSourceFB);
av_wndMain.pnlSrcDest.rbSourceOP=av_wndMain.pnlSrcDest.add('radiobutton',[10,130,500,150],txt_rbSourceOP);
av_wndMain.pnlSrcDest.add('panel',[15,45,15,110],'');
av_wndMain.pnlSrcDest.rbFBActive=av_wndMain.pnlSrcDest.add('radiobutton',[30,45,500,65],txt_rbActive);
av_wndMain.pnlSrcDest.rbFBFlagged=av_wndMain.pnlSrcDest.add('radiobutton',[30,65,500,85],txt_rbFBFlagged);
av_wndMain.pnlSrcDest.rbFBSelected=av_wndMain.pnlSrcDest.add('radiobutton',[30,85,500,105],txt_rbFBSelected);
av_wndMain.pnlSrcDest.add('panel',[15,155,15,200],'');
av_wndMain.pnlSrcDest.rbOPActive=av_wndMain.pnlSrcDest.add('radiobutton',[30,155,500,175],txt_rbActive);
av_wndMain.pnlSrcDest.rbOPNew=av_wndMain.pnlSrcDest.add('radiobutton',[30,175,500,195],txt_rbOPNew);
var ui_LNTop=250;
av_wndMain.pnlNaming=av_wndMain.add('panel',[10,ui_LNTop,av_uiMainWndWidth-160,ui_LNTop+117],txt_pnlNaming);
av_wndMain.pnlNaming.rbLNByDoc=av_wndMain.pnlNaming.add('radiobutton',[10,20,300,40],txt_rbLNByDoc);
av_wndMain.pnlNaming.rbLNByNN=av_wndMain.pnlNaming.add('radiobutton',[10,40,300,60],txt_rbLNByNN);
av_wndMain.pnlNaming.add('statictext',[40,60,200,80],txt_stPrefix);
av_wndMain.pnlNaming.add('statictext',[210,60,320,80],txt_stStartValue);
av_wndMain.pnlNaming.edPrefix=av_wndMain.pnlNaming.add('edittext',[40,80,200,102],'');
av_wndMain.pnlNaming.edStart=av_wndMain.pnlNaming.add('edittext',[210,80,260,102],'');
av_wndMain.pnlNaming.add('panel',[15,65,15,107],'');
av_wndMain.btnRun=av_wndMain.add('button',[av_uiMainWndWidth-150,ui_LNTop+7,av_uiMainWndWidth-10,ui_LNTop+75],txt_btnRun);
av_wndMain.btnCancel=av_wndMain.add('button',[av_uiMainWndWidth-150,ui_LNTop+85,av_uiMainWndWidth-10,ui_LNTop+115],txt_btnCancel);
av_wndMain.defaultElement=av_wndMain.btnRun;
av_wndMain.cancelElement=av_wndMain.btnCancel;
av_wndMain.av_stAV = av_wndMain.add('statictext',[10,av_uiMainWndHeight-30,av_uiMainWndWidth-10,av_uiMainWndHeight-10],txt_stCopyright);
return true;
}
function InitUIState(){
with (av_ScriptMainObject.wndMain.pnlSrcDest){
if (!g_CollectedHostInfo.HaveManyOpenDocuments) {
rbSourceOP.enabled=false;
rbOPActive.enabled=false;
rbOPNew.enabled=false;
}else{
rbSourceOP.enabled=true;
rbOPActive.enabled=g_CollectedHostInfo.HaveActiveDocument;
rbOPNew.enabled=g_CollectedHostInfo.HaveActiveDocument;
if ((!rbOPActive.enabled) && (!rbOPNew.enabled)) rbSourceOP.enabled=false;
}
if (!g_CollectedHostInfo.HaveSelectedFilesInFB) {
rbSourceFB.enabled=false;
rbFBActive.enabled=false;
rbFBFlagged.enabled=false;
rbFBSelected.enabled=false;
}else{
rbSourceFB.enabled=true;
rbFBActive.enabled=g_CollectedHostInfo.HaveActiveDocument;
rbFBFlagged.enabled=g_CollectedHostInfo.HaveFlaggedInFB;
rbFBSelected.enabled=true;
}
rbSourceOP.value=(g_Settings.Source==gc_Source_OP);
rbSourceFB.value=(g_Settings.Source==gc_Source_FB);
rbFBActive.value=(g_Settings.Destination_FB==gc_FB_Destination_Active);
rbFBFlagged.value=(g_Settings.Destination_FB==gc_FB_Destination_FlaggedLike);
rbFBSelected.value=(g_Settings.Destination_FB==gc_FB_Destination_SelectedLike);
rbOPActive.value=(g_Settings.Destination_OP==gc_OP_Destination_Active);
rbOPNew.value=(g_Settings.Destination_OP==gc_OP_Destination_New);
}
with (av_ScriptMainObject.wndMain.pnlNaming){
rbLNByDoc.value=(g_Settings.Naming==gc_Naming_Document);
rbLNByNN.value=(g_Settings.Naming==gc_Naming_Number);
edPrefix.text=g_Settings.Naming_Prefix;
var val=parseInt(g_Settings.Naming_StartNumber+" ");
if (isNaN(val)) val=1;
edStart.text=val;
}
return true;
}
function InitUIEvents(){
with (av_ScriptMainObject.wndMain.pnlSrcDest){
rbSourceFB.onClick=function(){
g_Settings.Source=gc_Source_FB;
};
rbFBActive.onClick=function(){
rbSourceFB.value=true;
g_Settings.Source=gc_Source_FB;
g_Settings.Destination_FB=gc_FB_Destination_Active;
};
rbFBFlagged.onClick=function(){
rbSourceFB.value=true;
g_Settings.Source=gc_Source_FB;
g_Settings.Destination_FB=gc_FB_Destination_FlaggedLike;
};
rbFBSelected.onClick=function(){
rbSourceFB.value=true;
g_Settings.Source=gc_Source_FB;
g_Settings.Destination_FB=gc_FB_Destination_SelectedLike;
};
rbSourceOP.onClick=function(){
g_Settings.Source=gc_Source_OP;
};
rbOPActive.onClick=function(){
rbSourceOP.value=true;
g_Settings.Source=gc_Source_OP;
g_Settings.Destination_OP=gc_OP_Destination_Active;
};
rbOPNew.onClick=function(){
rbSourceOP.value=true;
g_Settings.Source=gc_Source_OP;
g_Settings.Destination_OP=gc_OP_Destination_New;
};
}
with (av_ScriptMainObject.wndMain.pnlNaming){
rbLNByDoc.onClick=function(){
g_Settings.Naming=gc_Naming_Document;
};
rbLNByNN.onClick=function(){
g_Settings.Naming=gc_Naming_Number;
};
edPrefix.onChange=function(){
rbLNByNN.value=true;
g_Settings.Naming=gc_Naming_Number;
g_Settings.Naming_Prefix=this.text;
};
edStart.onChange=function(){
rbLNByNN.value=true;
g_Settings.Naming=gc_Naming_Number;
g_Settings.Naming_StartNumber=parseInt(this.text);
if (isNaN(g_Settings.Naming_StartNumber)) g_Settings.Naming_StartNumber=1;
this.text=g_Settings.Naming_StartNumber;
};
}
return true;
}
function Run(){
if (av_ScriptMainObject.wndMain==null) return;
if (av_wrkDoModal(av_ScriptMainObject.wndMain)==1){
SaveLastSettings();
DoTheJob();
}
}
function DoTheJob(){
var err_NoDestDocument="Cannot create the destination document.";
var err_CannotProcessSourceDocuments="Cannot process the source document(s).";
var destDocRef=null;
var theOpenedDocument=null;
try{
var clearTheDestDocument=false;
if (g_Settings.Source==gc_Source_FB){
switch (g_Settings.Destination_FB){
case gc_FB_Destination_Active:
destDocRef=av_ScriptMainObject.startDocRef;
break;
case gc_FB_Destination_SelectedLike:
if (g_CollectedHostInfo.FBObject.count>0){
var theFile=g_CollectedHostInfo.FBObject.list[0];
theOpenedDocument=open(theFile);
if (theOpenedDocument!=null){
destDocRef=theOpenedDocument.duplicate();
theOpenedDocument.close();
theOpenedDocument=null;
clearTheDestDocument=true;
}
}
break;
case gc_FB_Destination_FlaggedLike:
if (g_CollectedHostInfo.FBObject.firstFlaggedFile!=null){
var theFile=g_CollectedHostInfo.FBObject.firstFlaggedFile;
theOpenedDocument=open(theFile);
if (theOpenedDocument!=null){
destDocRef=theOpenedDocument.duplicate();
theOpenedDocument.close();
theOpenedDocument=null;
clearTheDestDocument=true;
}
}
break;
}
}
if (g_Settings.Source==gc_Source_OP){
switch (g_Settings.Destination_OP){
case gc_OP_Destination_Active:
destDocRef=av_ScriptMainObject.startDocRef;
break;
case gc_OP_Destination_New:
destDocRef=av_ScriptMainObject.startDocRef.duplicate();
clearTheDestDocument=true;
break;
}
}
if ((clearTheDestDocument) && (destDocRef!=null)){
destDocRef.flatten();
destDocRef.backgroundLayer.clear();
}
}
catch (e){
if (theOpenedDocument!=null) theOpenedDocument.close();
theOpenedDocument=null;
destDocRef=null;
}
if (destDocRef==null) {
alert(err_NoDestDocument);
return;
}
theOpenedDocument=null;
var theGlobalCounter=parseInt(g_Settings.Naming_StartNumber);
if (isNaN(theGlobalCounter)) theGlobalCounter=1;
try{
if (g_Settings.Source==gc_Source_FB){
for (var i=0;i<g_CollectedHostInfo.FBObject.count;i++){
var theFile=g_CollectedHostInfo.FBObject.list[i];
var nnOfCurentlyOpenedDocs=this.documents.length;
theOpenedDocument=open(theFile);
var theDocName=theOpenedDocument.name;
if (nnOfCurentlyOpenedDocs==this.documents.length) {
theOpenedDocument=theOpenedDocument.duplicate();
}
theOpenedDocument.selection.selectAll();
var doThePaste=false;
if ((theOpenedDocument.layerSets.length==0) && (theOpenedDocument.layers.length==1)){
if (theOpenedDocument.layers[0].visible){
theOpenedDocument.selection.copy(!theOpenedDocument.layers[0].isBackgroundLayer);
doThePaste=true;
}
}else if ((theOpenedDocument.layerSets.length>0) || (theOpenedDocument.layers.length>=1)){
if (theOpenedDocument.activeLayer.visible){
theOpenedDocument.selection.copy(true);
doThePaste=true;
}else{
for (var k=0;k<theOpenedDocument.layers.length;k++){
if (theOpenedDocument.layers[k].visible){
theOpenedDocument.activeLayer=theOpenedDocument.layers[k];
theOpenedDocument.selection.copy(true);
doThePaste=true;
break;
}
}
if (!doThePaste){
for (var k=0;k<theOpenedDocument.layerSets.length;k++){
if (theOpenedDocument.layerSets[k].visible){
theOpenedDocument.activeLayer=theOpenedDocument.layerSets[k];
theOpenedDocument.selection.copy(true);
doThePaste=true;
break;
}
}
}
}
}
if (doThePaste) {
this.activeDocument=destDocRef;
var theNewlayer=destDocRef.paste(false);
if (g_Settings.Naming==gc_Naming_Document){
theNewlayer.name=theDocName;
}else{
theNewlayer.name=g_Settings.Naming_Prefix+" "+theGlobalCounter;
theGlobalCounter++;
}
}
theOpenedDocument.close(SaveOptions.DONOTSAVECHANGES);
}
}
if (g_Settings.Source==gc_Source_OP){
for (var i=0;i<this.documents.length;i++){
if (this.documents[i]!=destDocRef){
this.activeDocument=this.documents[i];
theOpenedDocument=this.documents[i].duplicate();
theOpenedDocument.selection.selectAll();
var doThePaste=false;
if ((theOpenedDocument.layerSets.length==0) && (theOpenedDocument.layers.length==1)){
if (theOpenedDocument.layers[0].visible){
theOpenedDocument.selection.copy(!theOpenedDocument.layers[0].isBackgroundLayer);
doThePaste=true;
}
}else if ((theOpenedDocument.layerSets.length>0) || (theOpenedDocument.layers.length>=1)){
if (theOpenedDocument.activeLayer.visible){
theOpenedDocument.selection.copy(true);
doThePaste=true;
}else{
for (var k=0;k<theOpenedDocument.layers.length;k++){
if (theOpenedDocument.layers[k].visible){
theOpenedDocument.activeLayer=theOpenedDocument.layers[k];
theOpenedDocument.selection.copy(true);
doThePaste=true;
break;
}
}
if (!doThePaste){
for (var k=0;k<theOpenedDocument.layerSets.length;k++){
if (theOpenedDocument.layerSets[k].visible){
theOpenedDocument.activeLayer=theOpenedDocument.layerSets[k];
theOpenedDocument.selection.copy(true);
doThePaste=true;
break;
}
}
}
}
}
if (doThePaste) {
this.activeDocument=destDocRef;
var theNewlayer=destDocRef.paste(false);
if (g_Settings.Naming==gc_Naming_Document){
theNewlayer.name=this.documents[i].name;
}else{
theNewlayer.name=g_Settings.Naming_Prefix+" "+theGlobalCounter;
theGlobalCounter++;
}
}
theOpenedDocument.close(SaveOptions.DONOTSAVECHANGES);
}
}
}
}
catch(e){
if (theOpenedDocument!=null) theOpenedDocument.close();
alert(err_CannotProcessSourceDocuments);
}
}
function ScriptMain(){
if (av_wrkTestHost(true,false,true)){
try {
if (!av_wrkInitHostStartValues()) throw(0);
if (!CollectHostStateInfo()) throw(0);
if (!InitSettings_Defaults()) throw(0);
LoadLastSettings();
if (!ReInitSettingByStartConditions()) throw(0);
if (!BuildUI()) throw(0);
if (!InitUIState()) throw(0);
if (!InitUIEvents()) throw(0);
Run();
}
catch (e){
}
av_wrkRestoreHostStartValues();
}
}
ScriptMain();
