/////////////////////////////////////////////////////////////////////////////////////////
//																
//	                                 NN											
//	         ___JNN)      .___J      4N          _____.									
//	      JNNF"4NNN    .NN"4NN)      NN       JNF4L_F4NN.								
//	     (N`  .NNNF   JN` (NNF      JN`     JNF `NNN` NN)								
//	     (N) (NNNN)  (N`  NNN      JN`     JN`   NNN (NN)   _NNLJNN .JNNN.    .NNNL		
//	        (N)(NN`  (N) .NNN    .NN      .N)   (NNLJNN`  JNNNNNNF`JNF`4NN)  (NF`NN		
//	       (N) JNN    "` `NN)   JNF       (N    JNNNNNNN. "`NNNF  JNF  `NN)  (NN		
//	      (N`  NNN        NN) .NN`        (N)   NNN  (NN)  (NN)  (NN`   NN)  `NNN		
//	     (N""""NN)        NNLJNF          `NNN (NN)  .NN)  JNN   (NN   (NN    (NN)		
//	    JN`   (NN)        NNNN`             "" JNN`  JNN   NNF   (NN) .NN` NN).NN) .NN	
//	   JN`    NNNLJ)      NNF                .JNNF _NNF   (NN)    NNNNNF   4NNNNF  (NN	
//	._NN                  "`                `""""""""									
//	NNF															
//																		
/////////////////////////////////////////////////////////////////////////////////////////
//                               
//   Script for Adobe Photoshop CS and higher.  Copyright 2004 AV Bros.
//                             
/////////////////////////////////////////////////////////////////////////////////////////






/////////////////////////////////////////////////////////////////////////////////////////

$.level = 0;
var av_ScriptMainObject = new Object();
av_ScriptMainObject.msg_OnlyCS=			"This script is only for Adobe Photoshop CS and higher.";
av_ScriptMainObject.msg_OpenDocument=	"Please open or create the document before running the script.";
av_ScriptMainObject.msg_SelectDocument=	"Please select the document before running the script.";
av_ScriptMainObject.msg_IncorrectConfig="Broken config file, or incorrect version.";
av_ScriptMainObject.wndMain=null;
av_ScriptMainObject.startRulerUnits=null;
av_ScriptMainObject.startTypeUnits=null;
av_ScriptMainObject.startDialogsMode=null;
av_ScriptMainObject.startDocRef=null;
function av_wrkInitHostStartValues(){
if (av_ScriptMainObject==null) return false;
try{
if (this.documents.length>0)
av_ScriptMainObject.startDocRef = this.activeDocument;
}
catch(e){
av_ScriptMainObject.startDocRef=null;
}
try{
av_ScriptMainObject.startRulerUnits  = this.preferences.rulerUnits;
av_ScriptMainObject.startTypeUnits  = this.preferences.typeUnits;
av_ScriptMainObject.startDialogsMode  = this.displayDialogs;
}
catch(e){
}
return true;
}
function av_wrkRestoreHostStartValues(){
if (av_ScriptMainObject==null) return false;
if ((this.preferences.rulerUnits!=av_ScriptMainObject.startRulerUnits) && (av_ScriptMainObject.startRulerUnits!=null)){
this.preferences.rulerUnits=av_ScriptMainObject.startRulerUnits;
}
if ((this.preferences.typeUnits!=av_ScriptMainObject.startTypeUnits) && (av_ScriptMainObject.startTypeUnits!=null)){
this.preferences.typeUnits=av_ScriptMainObject.startTypeUnits;
}
if ((this.displayDialogs!=av_ScriptMainObject.startDialogsMode) && (av_ScriptMainObject.startDialogsMode!=null)){
this.displayDialogs=av_ScriptMainObject.startDialogsMode;
}
return true;
}
function av_wrkInitHostParams(Units,TypeUnits,DisplayDialogs){
if (Units!=null){
this.preferences.rulerUnits=Units;
}
if (TypeUnits!=null){
this.preferences.typeUnits=TypeUnits;
}
if (DisplayDialogs!=null){
this.displayDialogs=DisplayDialogs;
}
}
function av_wrkTestHost(OnlyCS,DocumentOpen,ShowErrors){
if (OnlyCS){
if (this.version.split(".")[0]<8) {
if (ShowErrors) alert(av_ScriptMainObject.msg_OnlyCS);
return false;
}
}
if (DocumentOpen){
if (this.documents.length==0){
if (ShowErrors) alert(av_ScriptMainObject.msg_OpenDocument);
return false;
}
var tmp_app=null;
try{
tmp_app=this.activeDocument;
}
catch(e){
tmp_app=null;
}
if (tmp_app==null){
if (ShowErrors) alert(av_ScriptMainObject.msg_SelectDocument);
return false;
}
}
return true;
}
function av_wrkDoModal(TheWindow){
if (TheWindow==null) return 0;
return TheWindow.show();
}
function av_wrkCheckForSelection(){
if (av_ScriptMainObject.startDocRef==null) return false;
try{
var ref=new ActionReference();
ref.putProperty(charIDToTypeID("Chnl"), charIDToTypeID("fsel"));
var desc=new ActionDescriptor();
desc.putReference(charIDToTypeID("null"),ref);
executeAction(charIDToTypeID("Trnf"),desc,DialogModes.NO);
}
catch(e){
return false;
}
return true;
}
function av_wrkWriteDataToFile(theFile,theData,showErrors){
try{
var av_file=new File(theFile);
av_file.open('w','TEXT','????');
var DataString="";
av_file.write(theData.version+"\n\n");
for (i=0;i<theData.count;i++){
av_file.write(theData.data.name[i]+":"+theData.data.value[i]+"\n");
}
av_file.close();
}
catch (err){
if (showErrors) alert(err);
return false;
}
return true;
}
function av_wrkReadDataFromFile(theFile,showErrors,versionString){
theReturnData=new Object();
theReturnData.count=0;
theReturnData.data=new Object();
theReturnData.data.name=new Array();
theReturnData.data.value=new Array();
try{
var av_file=new File(theFile);
av_file.open('r','TEXT','????');
var DataString="";
var firstLine=true;
while (!av_file.eof){
DataString=av_file.readln();
if (firstLine){
if (DataString!=versionString){
throw(av_ScriptMainObject.msg_IncorrectConfig);
}
firstLine=false;
}
var dataArray=DataString.split(":");
if ((dataArray[0]!=null) && (dataArray[0]!="")){
theReturnData.data.name[theReturnData.count]=dataArray[0];
theReturnData.data.value[theReturnData.count]=DataString.substr(dataArray[0].length+1);
theReturnData.count++;
}
}
av_file.close();
}
catch (err){
if (showErrors) alert(err);
return null;
}
return theReturnData;
}
function av_wrkDrawEllipticalSelection(x1,y1,x2,y2,SelectionMode,AA){
var setdID=charIDToTypeID("setd");
var addTID=charIDToTypeID("AddT");
var SbtFID=charIDToTypeID("SbtF");
var IntWID=charIDToTypeID("IntW");
var nullID=charIDToTypeID("null");
var chnlID=charIDToTypeID("Chnl");
var selID=charIDToTypeID("fsel");
var tID=charIDToTypeID("T   ");
var topID=charIDToTypeID("Top ");
var btmID=charIDToTypeID("Btom");
var leftID=charIDToTypeID("Left");
var rightID=charIDToTypeID("Rght");
var PixelsID=charIDToTypeID("#Pxl");
var ref=new ActionReference();
var desc=new ActionDescriptor();
ref.putProperty(chnlID,selID);
desc.putReference(nullID,ref);
var desc2=new ActionDescriptor();
desc2.putUnitDouble(topID,PixelsID,y1);
desc2.putUnitDouble(leftID,PixelsID,x1);
desc2.putUnitDouble(btmID,PixelsID,y2);
desc2.putUnitDouble(rightID,PixelsID,x2);
desc.putObject(tID,charIDToTypeID("Elps"),desc2);
desc.putBoolean( charIDToTypeID("AntA"),AA);
switch (SelectionMode){
case "New":
executeAction(setdID,desc,DialogModes.NO);
break;
case "Add":
executeAction(addTID,desc,DialogModes.NO);
break;
case "Intersect":
executeAction(IntWID,desc,DialogModes.NO);
break;
case "Subtract":
executeAction(SbtFID,desc,DialogModes.NO);
break;
}
}
function av_wrkAddGuide(pixelPos,vert){
try {
var GuideDesc=new ActionDescriptor();
GuideDesc.putUnitDouble(charIDToTypeID("Pstn"),charIDToTypeID("#Pxl"),pixelPos);
var OrntID=charIDToTypeID("Ornt");
var VerticalID=charIDToTypeID("Vrtc");
var HorizontalID=charIDToTypeID("Hrzn");
GuideDesc.putEnumerated( OrntID, OrntID, (vert)?VerticalID:HorizontalID );
var desc=new ActionDescriptor();
desc.putObject(charIDToTypeID("Nw  "),charIDToTypeID("Gd  "),GuideDesc);
executeAction(charIDToTypeID("Mk  "), desc, DialogModes.NO);
}
catch (e){
}
}
var g_PathPointsArray=new Array();
function GetWorkPathPoints(NNPoints){
var thePathItems=av_ScriptMainObject.startDocRef.pathItems;
if (thePathItems==null) return false;
if (!(thePathItems instanceof PathItems)) return false;
var theWorkPath=null;
for (var i=0;i<thePathItems.length;i++){
if (thePathItems[i].kind==PathKind.WORKPATH){
theWorkPath=thePathItems[i].subPathItems;
if ((theWorkPath!=null) && (theWorkPath instanceof SubPathItems)) break;
}
}
if ((theWorkPath==null) || (!(theWorkPath instanceof SubPathItems))) return false;
if (theWorkPath.length<1) return false;
var pPoints=theWorkPath[0].pathPoints;
if ((pPoints==null) || (!(pPoints instanceof PathPoints))) return false;
if (pPoints.length<NNPoints) return false;
for (var i=0;i<pPoints.length;i++){
if (pPoints[i] instanceof PathPoint)
g_PathPointsArray[i]=pPoints[i];
else return false;
}
return true;
}
var g_CircleObject=new Object();
g_CircleObject.x=null;
g_CircleObject.y=null;
g_CircleObject.R=null;
function CalculateTheCircle(){
if ((g_Settings.Operation==gc_Op_By3) && (g_3PointsOk)){
var Coors=new Array();
Coors[0]=g_PathPointsArray[0].anchor;
Coors[1]=g_PathPointsArray[1].anchor;
Coors[2]=g_PathPointsArray[2].anchor;
var ABlen=Math.sqrt((Coors[0][0]-Coors[1][0])*(Coors[0][0]-Coors[1][0])+(Coors[0][1]-Coors[1][1])*(Coors[0][1]-Coors[1][1]));
var BClen=Math.sqrt((Coors[1][0]-Coors[2][0])*(Coors[1][0]-Coors[2][0])+(Coors[1][1]-Coors[2][1])*(Coors[1][1]-Coors[2][1]));
var AClen=Math.sqrt((Coors[2][0]-Coors[0][0])*(Coors[2][0]-Coors[0][0])+(Coors[2][1]-Coors[0][1])*(Coors[2][1]-Coors[0][1]));
var s=(ABlen+BClen+AClen)/2;
var K=s*(s-ABlen)*(s-BClen)*(s-AClen);
if (K<=0) return false;
var R=ABlen*BClen*AClen/(4*Math.sqrt(K));
if (!isFinite(R)) return false;
g_CircleObject.R=R;
var D=(Coors[0][0]-Coors[2][0])*(Coors[1][1]-Coors[2][1])-(Coors[1][0]-Coors[2][0])*(Coors[0][1]-Coors[2][1]);
if (D==0) return false;
var X=(((Coors[0][0]-Coors[2][0])*(Coors[0][0]+Coors[2][0])+(Coors[0][1]-Coors[2][1])*(Coors[0][1]+Coors[2][1]))/2*(Coors[1][1]-Coors[2][1])-((Coors[1][0]-Coors[2][0])*(Coors[1][0]+Coors[2][0]) + (Coors[1][1]-Coors[2][1]) * (Coors[1][1]+Coors[2][1]))/2*(Coors[0][1]-Coors[2][1]))/D;
if (!isFinite(X)) return false;
g_CircleObject.x=X;
var Y=(((Coors[1][0]-Coors[2][0])*(Coors[1][0]+Coors[2][0])+(Coors[1][1]-Coors[2][1])*(Coors[1][1]+Coors[2][1]))/2*(Coors[0][0]-Coors[2][0])-((Coors[0][0]-Coors[2][0])*(Coors[0][0]+Coors[2][0])+(Coors[0][1]-Coors[2][1])*(Coors[0][1]+Coors[2][1]))/2*(Coors[1][0]-Coors[2][0]))/D;
if (!isFinite(Y)) return false;
g_CircleObject.y=Y;
}else{
var Coors=new Array();
Coors[0]=g_PathPointsArray[0].anchor;
Coors[1]=g_PathPointsArray[1].anchor;
var ABlen=Math.sqrt((Coors[0][0]-Coors[1][0])*(Coors[0][0]-Coors[1][0])+(Coors[0][1]-Coors[1][1])*(Coors[0][1]-Coors[1][1]));
var R=ABlen/2;
if (R<=0) return false;
if (!isFinite(R)) return false;
g_CircleObject.R=R;
var X=(Coors[0][0]+Coors[1][0])/2;
var Y=(Coors[0][1]+Coors[1][1])/2;
if (!isFinite(X)) return false;
if (!isFinite(Y)) return false;
g_CircleObject.x=X;
g_CircleObject.y=Y;
}
return true;
}
function DrawSelection(){
var selMode="New";
switch (g_Settings.SelMode)	{
case gc_Sel_New:
selMode="New";
break;
case gc_Sel_Add:
selMode="Add";
break;
case gc_Sel_Int:
selMode="Intersect";
break;
case gc_Sel_Sub:
selMode="Subtract";
break;
}
av_wrkDrawEllipticalSelection(g_CircleObject.x-g_CircleObject.R,g_CircleObject.y-g_CircleObject.R,g_CircleObject.x+g_CircleObject.R,g_CircleObject.y+g_CircleObject.R,selMode,g_Settings.SelAA=="yes");
if (g_Settings.CenterGuides=="yes"){
av_wrkAddGuide(g_CircleObject.x,true);
av_wrkAddGuide(g_CircleObject.y,false);
}
}
var avc_ConfigFileVersionString="AV Bros. Circumscriber 1.1 Config File";
var avc_ConfigFileName="AVCircumscriber1.1.cfg";
var g_Settings=new Object();
var gc_Sel_New="New";
var gc_Sel_Add="Add";
var gc_Sel_Sub="Sub";
var gc_Sel_Int="Int";
var gc_Op_By3="By3Points";
var gc_Op_By2="By2Points";
var g_3PointsOk=true;
function InitSettings_Defaults(){
g_Settings.SelMode=gc_Sel_New;
g_Settings.SelAA="yes";
g_Settings.CenterGuides="no";
g_Settings.Operation=gc_Op_By3;
return true;
}
function LoadLastSettings(){
var DataObject=av_wrkReadDataFromFile("~/"+avc_ConfigFileName,false,avc_ConfigFileVersionString);
if (DataObject==null) return;
for (i=0;i<DataObject.count;i++){
var SplitArray=DataObject.data.name[i].split(".");
switch (SplitArray[0]){
case "Mode":
g_Settings.SelMode=DataObject.data.value[i];
break;
case "SelAA":
g_Settings.SelAA=DataObject.data.value[i];
break;
case "CenterGuides":
g_Settings.CenterGuides=DataObject.data.value[i];
break;
case "Operation":
g_Settings.Operation=DataObject.data.value[i];
break;
}
}
}
function SaveLastSettings(){
DataToStore=new Object();
DataToStore.count=0;
DataToStore.data=new Object();
DataToStore.data.name=new Array();
DataToStore.data.value=new Array();
DataToStore.version=avc_ConfigFileVersionString;
var k=0;
DataToStore.data.name[k]="Mode";
DataToStore.data.value[k]=g_Settings.SelMode;
k++;
DataToStore.data.name[k]="SelAA";
DataToStore.data.value[k]=g_Settings.SelAA;
k++;
DataToStore.data.name[k]="CenterGuides";
DataToStore.data.value[k]=g_Settings.CenterGuides;
k++;
DataToStore.data.name[k]="Operation";
DataToStore.data.value[k]=g_Settings.Operation;
k++;
DataToStore.count=k;
av_wrkWriteDataToFile("~/"+avc_ConfigFileName,DataToStore,false);
}
function DoTheUI(){
var av_uiMainWndWidth=430;
var av_uiMainWndHeight=265;
var txt_pnlMode="Selection Mode";
var txt_rbModeNew="New selection";
var txt_rbModeAdd="Add to selection";
var txt_rbModeSub="Subtract from selection";
var txt_rbModeIntersect="Intersect with selection";
var txt_cbAA="Anti-aliasing";
var txt_btnRun="Run";
var txt_btnCancel="Cancel";
var txt_pnlGuides="Guides";
var txt_cbAddGuides="Add center guides";
var txt_stCopyright="Copyright 2004 AV Bros.   Web: http://www.avbros.com";
var txt_pnlSelType="Operation";
var txt_rbBy3Points="Use first 3 Anchor Points";
var txt_rbBy2Points="Use first 2 Anchor Points";
var txt_stCopyright="Copyright 2004 AV Bros.   Web: http://www.avbros.com";
av_ScriptMainObject.wndMain = new Window('dialog','AV Bros. Circumscriber 1.1',[0,0,av_uiMainWndWidth,av_uiMainWndHeight]);
var av_wndMain=av_ScriptMainObject.wndMain;
if (av_wndMain==null) return false;
av_wndMain.center();
av_wndMain.av_pnlMode = av_wndMain.add('panel',[10,10,215,155],txt_pnlMode);
av_wndMain.av_pnlMode.av_rbModeNew = av_wndMain.av_pnlMode.add('radiobutton',[10,25,170,40],txt_rbModeNew);
av_wndMain.av_pnlMode.av_rbModeAdd = av_wndMain.av_pnlMode.add('radiobutton',[10,45,170,60],txt_rbModeAdd);
av_wndMain.av_pnlMode.av_rbModeSub = av_wndMain.av_pnlMode.add('radiobutton',[10,65,170,80],txt_rbModeSub);
av_wndMain.av_pnlMode.av_rbModeIns = av_wndMain.av_pnlMode.add('radiobutton',[10,85,170,100],txt_rbModeIntersect);
av_wndMain.av_pnlMode.add('panel',[10,110,195,110],"");
av_wndMain.av_pnlMode.av_cbAA = av_wndMain.av_pnlMode.add('checkbox',[10,120,170,135],txt_cbAA);
if (g_Settings.SelAA=="yes") av_wndMain.av_pnlMode.av_cbAA.value=true;
if (!av_wrkCheckForSelection()){
av_wndMain.av_pnlMode.av_rbModeAdd.enabled=false;
av_wndMain.av_pnlMode.av_rbModeSub.enabled=false;
av_wndMain.av_pnlMode.av_rbModeIns.enabled=false;
av_wndMain.av_pnlMode.av_rbModeNew.value=true;
g_Settings.SelMode=gc_Sel_New;
}else{
switch (g_Settings.SelMode){
case gc_Sel_New:
av_wndMain.av_pnlMode.av_rbModeNew.value=true;
break;
case gc_Sel_Add:
av_wndMain.av_pnlMode.av_rbModeAdd.value=true;
break;
case gc_Sel_Int:
av_wndMain.av_pnlMode.av_rbModeIns.value=true;
break;
case gc_Sel_Sub:
av_wndMain.av_pnlMode.av_rbModeSub.value=true;
break;
}
}
av_wndMain.btnRun = av_wndMain.add('button',[235,15,420,50],txt_btnRun);
av_wndMain.btnCancel = av_wndMain.add('button',[235,60,420,85],txt_btnCancel);
av_wndMain.defaultElement=av_wndMain.btnRun;
av_wndMain.cancelElement=av_wndMain.btnCancel;
av_wndMain.av_pnlGuides = av_wndMain.add('panel',[235,105,420,155],txt_pnlGuides);
av_wndMain.av_pnlGuides.av_cbGuides = av_wndMain.av_pnlGuides.add('checkbox',[10,25,175,40],txt_cbAddGuides);
if (g_Settings.CenterGuides=="yes") av_wndMain.av_pnlGuides.av_cbGuides.value=true;
av_wndMain.av_pnlSelType = av_wndMain.add('panel',[10,170,420,220],txt_pnlSelType);
av_wndMain.av_pnlSelType.av_rbBy2Points = av_wndMain.av_pnlSelType.add('radiobutton',[10,25,200,40],txt_rbBy2Points);
av_wndMain.av_pnlSelType.av_rbBy3Points = av_wndMain.av_pnlSelType.add('radiobutton',[200,25,400,40],txt_rbBy3Points);
if (!g_3PointsOk) av_wndMain.av_pnlSelType.av_rbBy3Points.enabled=false;
if (g_Settings.Operation==gc_Op_By3) av_wndMain.av_pnlSelType.av_rbBy3Points.value=true;
if (g_Settings.Operation==gc_Op_By2) av_wndMain.av_pnlSelType.av_rbBy2Points.value=true;
av_wndMain.av_stAV = av_wndMain.add('statictext',[10,av_uiMainWndHeight-30,av_uiMainWndWidth-10,av_uiMainWndHeight-10],txt_stCopyright);
with (av_wndMain.av_pnlMode){
av_rbModeNew.onClick=function(){
g_Settings.SelMode=gc_Sel_New;
};
av_rbModeAdd.onClick=function(){
g_Settings.SelMode=gc_Sel_Add;
};
av_rbModeSub.onClick=function(){
g_Settings.SelMode=gc_Sel_Sub;
};
av_rbModeIns.onClick=function(){
g_Settings.SelMode=gc_Sel_Int;
};
av_cbAA.onClick=function(){
g_Settings.SelAA="no";
if (this.value) g_Settings.SelAA="yes";
};
}
with (av_wndMain.av_pnlGuides){
av_cbGuides.onClick=function(){
g_Settings.CenterGuides="no";
if (this.value) g_Settings.CenterGuides="yes";
};
}
with (av_wndMain.av_pnlSelType){
av_rbBy3Points.onClick=function(){
g_Settings.Operation=gc_Op_By3;
};
av_rbBy2Points.onClick=function(){
g_Settings.Operation=gc_Op_By2;
};
}
if (av_wrkDoModal(av_wndMain)!=1) return false;
return true;
}
function ScriptMain(){
try{
if (av_wrkTestHost(true,true,true)){
if (!av_wrkInitHostStartValues()) throw(0);
this.preferences.rulerUnits=Units.PIXELS;
if (!InitSettings_Defaults()) throw(0);
LoadLastSettings();
if (!GetWorkPathPoints(3)) {
if (!GetWorkPathPoints(2)) {
alert("Cannot find the workpath, or not enough anchor points in workpath.");
throw(0);
}
g_3PointsOk=false;
g_Settings.Operation=gc_Op_By2;
}
if (!DoTheUI()) throw(0);
if (!CalculateTheCircle()){
alert("Cannot calculate the circumscribe circle.");
throw(0);
}
SaveLastSettings();
DrawSelection();
}
}
catch (e){
}
av_wrkRestoreHostStartValues();
}
ScriptMain();
